'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getDisplayName = require('recompose/getDisplayName');

var _getDisplayName2 = _interopRequireDefault(_getDisplayName);

var _falcorShape = require('../utils/falcorShape');

var _falcorShape2 = _interopRequireDefault(_falcorShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$prop = _ref.prop,
      prop = _ref$prop === undefined ? 'falcor' : _ref$prop;

  return function (WrappedComponent) {
    var WithFalcor = function WithFalcor(props, context) {
      return _react2.default.createElement(WrappedComponent, (0, _extends3.default)({}, props, (0, _defineProperty3.default)({}, prop, context.falcor)));
    };

    WithFalcor.displayName = 'withFalcor(' + (0, _getDisplayName2.default)(WrappedComponent) + ')';

    WithFalcor.contextTypes = {
      falcor: _falcorShape2.default
    };

    return WithFalcor;
  };
};
//# sourceMappingURL=withFalcor.js.map