'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = createHOC;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _getDisplayName = require('recompose/getDisplayName');

var _getDisplayName2 = _interopRequireDefault(_getDisplayName);

var _shallowEqual = require('recompose/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _falcorShape = require('./falcorShape');

var _falcorShape2 = _interopRequireDefault(_falcorShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createHOC(createHandler) {
  for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    args[_key - 2] = arguments[_key];
  }

  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$defer = _ref.defer,
      defer = _ref$defer === undefined ? false : _ref$defer,
      _ref$pure = _ref.pure,
      pure = _ref$pure === undefined ? true : _ref$pure,
      loadingComponent = _ref.loadingComponent,
      _ref$getDisplayName = _ref.getDisplayName,
      getDisplayName = _ref$getDisplayName === undefined ? function (name) {
    return 'Resolve(' + name + ')';
  } : _ref$getDisplayName;

  var Loading = loadingComponent;

  return function (WrappedComponent) {
    var Resolve = function (_React$Component) {
      (0, _inherits3.default)(Resolve, _React$Component);

      function Resolve(props, context) {
        (0, _classCallCheck3.default)(this, Resolve);

        var _this = (0, _possibleConstructorReturn3.default)(this, (Resolve.__proto__ || (0, _getPrototypeOf2.default)(Resolve)).call(this, props, context));

        _this.onModelChange = function () {
          _this.subscribe(_this.props);
        };

        _this.eventEmitter = context.falcor.eventEmitter;
        _this.falcor = context.falcor.model;

        _this.handler = createHandler.apply(undefined, args);
        _this.state = _this.handler.defaultState;
        return _this;
      }

      (0, _createClass3.default)(Resolve, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          if (!defer) {
            this.listenAndSubscribe();
          }
        }
      }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
          if (defer) {
            this.listenAndSubscribe();
          }
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          var _this2 = this;

          if (!pure || !(0, _shallowEqual2.default)(nextProps, this.props)) {
            this.setState({ loading: true }, function () {
              _this2.subscribe(nextProps);
            });
          }
        }
      }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
          if (this.version !== this.falcor.getVersion()) {
            return true;
          }
          return !pure || !(0, _shallowEqual2.default)(this.props, nextProps) || !(0, _shallowEqual2.default)(this.state, nextState);
        }
      }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate() {
          this.version = this.falcor.getVersion();
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.eventEmitter.removeListener('change', this.onModelChange);
          this.eventEmitter = null;

          this.handler.unsubscribe();
          this.handler = null;

          this.falcor = null;
          this.version = null;
        }
      }, {
        key: 'listenAndSubscribe',
        value: function listenAndSubscribe() {
          this.eventEmitter.on('change', this.onModelChange);
          this.subscribe(this.props);
        }
      }, {
        key: 'subscribe',
        value: function subscribe(props) {
          var _this3 = this;

          if (this.falcor === null) {
            return;
          }
          this.handler.unsubscribe();

          this.handler.subscribe(this.falcor, props, function (state) {
            // HACK avoid server-side rendering setState() no-op
            // this is happened when calling renderToString(),
            // this callback is run after component is rendered,
            // which triggering the warning
            if (_this3.updater && _this3.updater.transaction && _this3.updater.transaction._isInTransaction === false) {
              return;
            }

            _this3.setState(state);
          });
        }
      }, {
        key: 'render',
        value: function render() {
          if (this.state.loading) {
            return Loading ? _react2.default.createElement(Loading, this.props) : null;
          }
          var props = this.handler.computeProps(this.props, this.state);
          if (props === null) {
            return null;
          }
          return _react2.default.createElement(WrappedComponent, props);
        }
      }]);
      return Resolve;
    }(_react2.default.Component);

    Resolve.displayName = getDisplayName((0, _getDisplayName2.default)(WrappedComponent));


    Resolve.contextTypes = {
      // eslint-disable-next-line react/no-typos
      falcor: _falcorShape2.default.isRequired
    };

    return (0, _hoistNonReactStatics2.default)(Resolve, WrappedComponent);
  };
}
//# sourceMappingURL=createHOC.js.map